module Star where

import Data.WrapAround (WP)
import Animation (Animation(..))
import Graphics.Gloss.Data.Picture (rectangleSolid, Picture(..))
import Graphics.Gloss.Data.Color (Color)
import Moving (Locatable(..))

data Star = Star { location :: WP
                 , color :: Color
                 }

instance Animation Star where
  image star _ = Color (Star.color star) (rectangleSolid 1.0 1.0)

instance Locatable Star where
  center = location

